sidebarNodes={"extras":[{"group":"","headers":[{"anchor":"modules","id":"Modules"}],"id":"api-reference","title":"API Reference"},{"group":"Introduction","headers":[{"anchor":"how-to-install-ergo","id":"How to install Ergo."}],"id":"overview","title":"Overview"},{"group":"Introduction","headers":[],"id":"parser_combinator_intro","title":"Intro to Parser Combinators"},{"group":"Introduction","headers":[],"id":"comparisons","title":"Comparisons with other libraries"},{"group":"Introduction","headers":[{"anchor":"parsing-a-digit","id":"Parsing a digit"},{"anchor":"parsing-many-digits","id":"Parsing many digits"},{"anchor":"parsing-negative-numbers","id":"Parsing negative numbers"},{"anchor":"parsing-decimals","id":"Parsing decimals"},{"anchor":"conclusion","id":"Conclusion"}],"id":"basic_parser","title":"Creating a Basic Parser"},{"group":"Introduction","headers":[],"id":"debugging","title":"Debugging"},{"group":"Introduction","headers":[{"anchor":"left-recursion","id":"Left Recursion"},{"anchor":"eager-recursion","id":"Eager Recursion"}],"id":"recursion","title":"Recursion"},{"group":"Introduction","headers":[{"anchor":"top-down-or-bottom-up","id":"Top-down or Bottom-up?"}],"id":"guidance","title":"General Guidance"}],"modules":[{"group":"","id":"Ergo","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"parse/3","id":"parse/3"},{"anchor":"start/2","id":"start/2"}]}],"sections":[{"anchor":"module-getting-help","id":"Getting Help"},{"anchor":"module-installing","id":"Installing"},{"anchor":"module-a-basic-parser","id":"A Basic Parser"},{"anchor":"module-what-is-a-parser","id":"What is a parser?"},{"anchor":"module-the-context","id":"The Context"},{"anchor":"module-the-context-in-detail","id":"The Context in detail"},{"anchor":"module-terminal-parsers","id":"Terminal Parsers"},{"anchor":"module-numeric-parsers","id":"Numeric parsers"},{"anchor":"module-combinator-parsers","id":"Combinator Parsers"}],"title":"Ergo"},{"group":"","id":"Ergo.Combinators","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"atom/1","id":"atom/1"},{"anchor":"choice/2","id":"choice/2"},{"anchor":"hoist/1","id":"hoist/1"},{"anchor":"ignore/2","id":"ignore/2"},{"anchor":"lazy/1","id":"lazy/1"},{"anchor":"lookahead/2","id":"lookahead/2"},{"anchor":"many/2","id":"many/2"},{"anchor":"not_lookahead/2","id":"not_lookahead/2"},{"anchor":"optional/2","id":"optional/2"},{"anchor":"parse_many/5","id":"parse_many/5"},{"anchor":"replace/3","id":"replace/3"},{"anchor":"satisfy/3","id":"satisfy/3"},{"anchor":"sequence/2","id":"sequence/2"},{"anchor":"string/1","id":"string/1"},{"anchor":"transform/3","id":"transform/3"}]}],"sections":[],"title":"Ergo.Combinators"},{"group":"","id":"Ergo.Context","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"add_error/3","id":"add_error/3"},{"anchor":"ast_in_parsed_order/1","id":"ast_in_parsed_order/1"},{"anchor":"ast_to_string/1","id":"ast_to_string/1"},{"anchor":"ast_transform/2","id":"ast_transform/2"},{"anchor":"ast_without_ignored/1","id":"ast_without_ignored/1"},{"anchor":"clip/2","id":"clip/2"},{"anchor":"commit/1","id":"commit/1"},{"anchor":"dec_depth/1","id":"dec_depth/1"},{"anchor":"inc_depth/1","id":"inc_depth/1"},{"anchor":"new/2","id":"new/2"},{"anchor":"next_char/1","id":"next_char/1"},{"anchor":"parent_parser/1","id":"parent_parser/1"},{"anchor":"parser_tracked?/2","id":"parser_tracked?/2"},{"anchor":"peek/1","id":"peek/1"},{"anchor":"pop_parser/1","id":"pop_parser/1"},{"anchor":"push_parser/2","id":"push_parser/2"},{"anchor":"reset_status/1","id":"reset_status/1"},{"anchor":"set_ast/2","id":"set_ast/2"},{"anchor":"track_parser/3","id":"track_parser/3"},{"anchor":"uncommit/1","id":"uncommit/1"}]}],"sections":[],"title":"Ergo.Context"},{"group":"","id":"Ergo.Meta","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"around/2","id":"around/2"},{"anchor":"capture/3","id":"capture/3"},{"anchor":"commit/0","id":"commit/0"},{"anchor":"failed/3","id":"failed/3"}]}],"sections":[],"title":"Ergo.Meta"},{"group":"","id":"Ergo.Numeric","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"decimal/1","id":"decimal/1"},{"anchor":"digits/1","id":"digits/1"},{"anchor":"number/1","id":"number/1"},{"anchor":"uint/1","id":"uint/1"}]}],"sections":[],"title":"Ergo.Numeric"},{"group":"","id":"Ergo.Outline.Builder","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"append/2","id":"append/2"},{"anchor":"build_from_events/1","id":"build_from_events/1"},{"anchor":"insert/1","id":"insert/1"},{"anchor":"insert/2","id":"insert/2"},{"anchor":"is_branch/1","id":"is_branch/1"},{"anchor":"kids/1","id":"kids/1"},{"anchor":"make_node/2","id":"make_node/2"},{"anchor":"root_node/0","id":"root_node/0"},{"anchor":"tree/0","id":"tree/0"},{"anchor":"walk/2","id":"walk/2"},{"anchor":"walk_node/2","id":"walk_node/2"}]}],"sections":[],"title":"Ergo.Outline.Builder"},{"group":"","id":"Ergo.Outline.OPML","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"generate_node/2","id":"generate_node/2"},{"anchor":"generate_opml/2","id":"generate_opml/2"},{"anchor":"generate_opml_node/11","id":"generate_opml_node/11"},{"anchor":"opml_event_info/1","id":"opml_event_info/1"},{"anchor":"opml_event_input/1","id":"opml_event_input/1"},{"anchor":"opml_event_match/1","id":"opml_event_match/1"},{"anchor":"opml_event_name/1","id":"opml_event_name/1"},{"anchor":"opml_event_pos/2","id":"opml_event_pos/2"},{"anchor":"opml_event_status/1","id":"opml_event_status/1"},{"anchor":"opml_event_tagend/1","id":"opml_event_tagend/1"},{"anchor":"opml_event_text/2","id":"opml_event_text/2"},{"anchor":"to_xml_attr_value/1","id":"to_xml_attr_value/1"}]}],"sections":[],"title":"Ergo.Outline.OPML"},{"group":"","id":"Ergo.Parser","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"child_info_for_telemetry/1","id":"child_info_for_telemetry/1"},{"anchor":"combinator/4","id":"combinator/4"},{"anchor":"invoke/2","id":"invoke/2"},{"anchor":"pop_entry_point/1","id":"pop_entry_point/1"},{"anchor":"push_entry_point/1","id":"push_entry_point/1"},{"anchor":"terminal/4","id":"terminal/4"},{"anchor":"track_parser/1","id":"track_parser/1"}]}],"sections":[],"title":"Ergo.Parser"},{"group":"","id":"Ergo.ParserRefs","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"child_spec/1","id":"child_spec/1"},{"anchor":"next_ref/0","id":"next_ref/0"},{"anchor":"start_link/1","id":"start_link/1"}]}],"sections":[],"title":"Ergo.ParserRefs"},{"group":"","id":"Ergo.Telemetry","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"enter/1","id":"enter/1"},{"anchor":"event/3","id":"event/3"},{"anchor":"get_events/1","id":"get_events/1"},{"anchor":"leave/1","id":"leave/1"},{"anchor":"result/1","id":"result/1"},{"anchor":"start/0","id":"start/0"}]}],"sections":[],"title":"Ergo.Telemetry"},{"group":"","id":"Ergo.TelemetryServer","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"child_spec/1","id":"child_spec/1"},{"anchor":"get_events/1","id":"get_events/1"},{"anchor":"handle_event/4","id":"handle_event/4"},{"anchor":"init/1","id":"init/1"},{"anchor":"reset/0","id":"reset/0"},{"anchor":"start_link/1","id":"start_link/1"}]}],"sections":[],"title":"Ergo.TelemetryServer"},{"group":"","id":"Ergo.TelemetryServer.State","sections":[],"title":"Ergo.TelemetryServer.State"},{"group":"","id":"Ergo.Terminals","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"alpha/1","id":"alpha/1"},{"anchor":"any/0","id":"any/0"},{"anchor":"captured_literal/1","id":"captured_literal/1"},{"anchor":"char/2","id":"char/2"},{"anchor":"delimited_text/3","id":"delimited_text/3"},{"anchor":"digit/1","id":"digit/1"},{"anchor":"eoi/0","id":"eoi/0"},{"anchor":"literal/2","id":"literal/2"},{"anchor":"not_char/2","id":"not_char/2"},{"anchor":"wc/0","id":"wc/0"},{"anchor":"ws/1","id":"ws/1"}]}],"sections":[],"title":"Ergo.Terminals"},{"group":"","id":"Ergo.Utils","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"ellipsize/2","id":"ellipsize/2"},{"anchor":"format_tracks/1","id":"format_tracks/1"},{"anchor":"printable_string/1","id":"printable_string/1"},{"anchor":"typeof/1","id":"typeof/1"}]}],"sections":[],"title":"Ergo.Utils"},{"group":"Exceptions","id":"Ergo.Parser.CycleError","sections":[],"title":"Ergo.Parser.CycleError"}],"tasks":[]}